#include"fc2722.h"
#include"E2PROM.H"

#define sw1  FP33
#define sw2  FP34//
#define l1   FP15
#define l2   FP16

unsigned int number=0;//¼Ƿһϵ
unsigned int motormode=0,bright=0;//
unsigned int shan_time=0,ff_time=0;
unsigned int time[15];
unsigned int limit,cishu,geshu,cnt;

unsigned int pwm[2],pich;
unsigned int speed,speed_mode;

unsigned int flag=0;
sbit on_off=flag:0;
sbit t0_use=flag:1;
sbit rf_ok=flag:2;
sbit z_write=flag:3;//ңغд
sbit z_delay=flag:4;//
sbit z_timer=flag:5;//ʱ

sbit zp=flag:6;
sbit zf=flag:7;

unsigned int map=0;
sbit rf_yes=map:0;

unsigned int open=0;//ػĴ
unsigned int breth;

#define hour  10//趨ʱʱ
//==============================================
//rf***********************************
#define use_h   0xff
#define use_l   0xff
#define pin_rf FP35
#define  start_min 80
#define  start_max 200
unsigned int rf_get_mode=0;
unsigned int rf_high_time,rf_low_time;
unsigned int rf_data[4];
unsigned int rf_count;
unsigned int rf_use_data;
//======================================

void delay_5u()
{__asm{nop}__asm{nop}__asm{nop}__asm{nop}
__asm{nop}__asm{nop}__asm{nop}__asm{nop}
__asm{nop}__asm{nop}__asm{nop}__asm{nop}
__asm{nop}__asm{nop}__asm{nop}__asm{nop}}

void delay_us(unsigned int i)
{
	while(i--);
}


#define pwm_number  166
/*************************************
t0ʱʼ  
ֵ=256-ʱ*12M/4/Ƶ
1000	256    0x80	******	1001	128    0x90	
1010	64     0xa0	******	1011	32     0xb0
1100	16     0xc0	******	1101	8      0xd0	
1110	4      0xe0	******	1111	2      0xf0
**************************************/

void T0Init()
{	

	T0M=0X80;//3.328ms
	T0C=100;//ֵ
	T0IF=0;	//־λ 
	T0IE=1;		//T0
	FGIE=1;		//ж
}
void Tm0Init()
{	

	TM0CL=0;  //1s
	TM0CH=0xff;
	TM0M=0x8e;   //

	FTM0IRQ=0;	//־λ0

	FTM0IEN=1;	//ʱж
}
void Tm1Init()
{	

	TM1C=136;  //20us
	TM1M=0xd6;   //

	FTM1IRQ=0;	//־λ0

	FTM1IEN=0;	//ʱж
}

void Tm2Init()
{	

	TM2C=0;  //85.3us
	TM2M=0xd2;   //

	FTM2IRQ=0;	//־λ0

	FTM2IEN=1;	//ʱж
}


void bright_mode()
{
	switch(bright)
	{
		case 10: geshu=100;limit=0;break;
		case 9:  geshu=78;limit=0;break;
		case 8:  geshu=70;limit=1;break;
		case 7:  geshu=62;limit=2;break;
		case 6:  geshu=55;limit=3;break;
		case 5:  geshu=44;limit=4;break;
		case 4:  geshu=36;limit=5;break;
		case 3:  geshu=27;limit=6;break;
		case 2:  geshu=19;limit=7;break;
		case 1:  geshu=10;limit=8;break;
		case 0:  geshu=2;limit=9;break;
	}
//	if(FTM1IRQ)
	{
		//FTM1IRQ=0;//5u
		time[1]++;
		if(time[1]>=85)
		{
			time[1]=0;
		}


		if(time[1]<geshu)
		{
		//	PWM1E=0x00;
			if(cnt==1){l1=1;PWM1E=0x00;}
			else     { l2=1;PWM1E=0x00;}
			time[2]=0;
		}
		else
		{
			/*time[2]++;
			if(cishu<limit)
			{
				if(time[2]<4)
				{
					if(cnt==1){l1=0;}
					else     { l2=0;}
				}
				else if(time[2]<5)
				{
					if(cnt==1){l1=1;}
					else     { l2=1;}
				}
				else
				{
					time[2]=0;cishu++;
					if(cnt==1){l1=0;}
					else     { l2=0;}
				}
			}
			else*/
			{
				//cishu=0;

						if(cnt==1){l1=0;PWM1E=0x21;TM1D1=pwm_number;}
						else     { l2=0;PWM1E=0x42;TM1D2=pwm_number;}
						/*
				if(cnt==1){l1=0;}
				else     { l2=0;}*/
			}
		}
	}





}

void breathe_mode()
{
	switch(bright)
	{
		case 10: pwm[0]=100;limit=0;break;
		case 9:  pwm[0]=78;limit=0;break;
		case 8:  pwm[0]=70;limit=1;break;
		case 7:  pwm[0]=62;limit=2;break;
		case 6:  pwm[0]=55;limit=3;break;
		case 5:  pwm[0]=44;limit=4;break;
		case 4:  pwm[0]=36;limit=5;break;
		case 3:  pwm[0]=27;limit=6;break;
		case 2:  pwm[0]=19;limit=7;break;
		case 1:  pwm[0]=10;limit=8;break;
		case 0:  pwm[0]=2;limit=9;break;
	}
switch(speed_mode)
{
	default: speed_mode=0;
	case 0: speed=1;break;
	case 1: speed=2;break;
	case 2: speed=4;break;
	case 3: speed=8;break;
}
//	if(FTM1IRQ)
	{
	//	FTM1IRQ=0;//5u
			//FP14=~FP14;
		time[3]++;
		if(time[3]>=85)
		{
			time[3]=0;
			
		}

			time[7]++;
			if(time[7]>=3)
			{
				time[5]++;
				time[7]=0;
				if(time[5]>=255)
				{
					time[5]=0;
					pich++;
				}
			}

			if(pwm[1]<128)
			{
				breth=1;
			}
			else
			{
				breth=2;
			}
		if(pich>=breth)
		{
			pich=0;
			if(zp)
			{
				if(pwm[1]<255-speed)
				{
				pwm[1]=speed+pwm[1];
				}
				else
				{
					zp=0;
				}
			}
			else
			{
				if(pwm[1]>1+speed)
				{
					pwm[1]=pwm[1]-speed;
				}
				else
				{
					zp=1;
					zf=~zf;
					if(zf)
					{
						speed_mode++;
					}
				}
			}
			
		}
		
		if(time[5]<pwm[1])
		{
			time[6]++;

				if(time[3]<pwm[0])
				{
					//PWM1E=0x00;
					if(cnt==1){l1=1;PWM1E=0x00;}
					else     { l2=1;PWM1E=0x00;}
					time[4]=0;
				}
				else
				{
				/*	time[4]++;
					if(cishu<limit)
					{
						if(time[4]<4)
						{
							if(cnt==1){l1=0;}
							else     { l2=0;}
						}
						else if(time[4]<5)
						{
							if(cnt==1){l1=1;}
							else     { l2=1;}
						}
						else
						{
							time[4]=0;cishu++;
							if(cnt==1){l1=0;}
							else     { l2=0;}
						}
					}
					else*/
					{
						//cishu=0;
						if(cnt==1){l1=0;PWM1E=0x21;TM1D1=pwm_number;}
						else     { l2=0;PWM1E=0x42;TM1D2=pwm_number;}
						/*
						if(cnt==1){l1=0;}
						else     { l2=0;}*/
						
					}
				}

		}
		else
		{
			PWM1E=0x00;
			if(cnt==1){l1=0;PWM1E=0x00;}
			else     { l2=0;PWM1E=0x00;}
			time[6]=0;
		}


	
	}
}
void choosemode()
{
	switch(motormode)
	{
		
		case 1: cnt=2;bright_mode();l1=0;break;
		case 2: cnt=1;bright_mode();l2=0;break;
		case 3: if(zf)
				{
					cnt=1;breathe_mode();l2=0;
				}
				else
				{
					cnt=2;breathe_mode();l1=0;
				}
				break;
		case 4: 
				if(ff_time<4)
				{
					cnt=1;bright_mode();l2=0;
				}
				else if(ff_time<8)
				{
					cnt=2;bright_mode();l1=0;
				}
				else
				{
					ff_time=0;l1=1;l2=0;cnt=1;
				}break;//0.6951s  
	}
}
/**************************
************ңݴ*****
*****************************/
void rf_batle()
{
	if(rf_ok)
	{
		rf_ok=0;
		z_write=1;
		z_delay=1;
		if(rf_use_data==0x01)//
		{ 
			on_off=1;open=10;
		}
		if(rf_use_data==0x03)//
		{ 
			on_off=0;z_timer=0;open=0;
		}
		if(on_off)
		{
			switch(rf_use_data)
			{
				case 0x04: motormode=1;break;//warm white
				case 0x06: motormode=2;break;//multi
				case 0x07: cishu=0;motormode=3;speed_mode=0;zf=1;zp=1;pwm[1]=1;break;//slo-gol
				case 0x09: cishu=0;motormode=4;break;//twinkle-flash
				case 0x0a: if(bright>0)
							{bright--;}
							else
							{
								bright=0;
								z_delay=0;z_write=0;
							}
				
							break;//-
				case 0x0c: if(bright<10)
							{bright++;}
							else
							{
								bright=10;
								z_delay=0;z_write=0;
							}
							break;//+

				case 0x02: z_timer=1;break;

			}
		}
		
	}
	else
	{
	
		if(z_write)
		{
			z_write=0;
			e2prom_write(0x02,motormode);
			e2prom_write(0x03,bright);	//д
			e2prom_write(0x05,open);	//д
		}
		
	}
}

void keydown()
{
	if(sw2)
	{
		if(time[11]>150)
		{
			on_off=~on_off;
			if(on_off){open=10;}
			else{open=0;}
			z_write=1;
		}
		time[11]=0;
	}
	else
	{
		if(time[11]<250)
		{
		time[11]++;
		}

	}
	if(sw1)
	{
		if(time[12]>150)
		{
			if(on_off)
			{
				motormode++;
				if(motormode>4)
				{motormode=1; }
				z_write=1;z_delay=1;
			}
		}
		time[12]=0;
	}
	else
	{
		if(time[12]<250)
		{
		time[12]++;
		}

	}
}
/*****************************************

*****************************************/
void main()
{	
	P1M=0xf8;
	P3M=0x00;
	P3UR=0x18;
	P1=0x00;
	P3=0x00;
	T0Init();
	Tm0Init();
  	Tm1Init();
	Tm2Init();
	
	number=e2prom_read(0x04);
	if(number!=100)
	{
		motormode=1;
		bright=10;
		number=100;	
		open=10;
e2prom_write(0x02,motormode);	//д
e2prom_write(0x03,bright);	//д
e2prom_write(0x04,number);
e2prom_write(0x05,open);	//д

	}
motormode=e2prom_read(0x02);
bright=e2prom_read(0x03);
open=e2prom_read(0x05);

if(open)
{
	on_off=1;
}
else
{
	on_off=0;
}

z_delay=0;
	
	while(1)
	{
		
		rf_batle();
		keydown();
		if(on_off&&z_delay==0)
		{
			choosemode();
		}
		else
		{l1=0;l2=0;PWM1E=0x00;}
		WDTR=0x5a;   		//忴Ź

	}		
}
void __interrupt[0x08] interrupt_isr(void)
{
	if(FTM2IRQ)
	{
		FTM2IRQ=0;	//־λ0
			
		if(rf_get_mode==0)
		{
				rf_count=0;
				rf_data[3]=0;
				if(pin_rf)
				{
				
					if((rf_low_time>start_min)&&(rf_low_time<start_max))
					{
						rf_get_mode=1;
					}
					else if(rf_low_time>220)
					{
						rf_yes=0;
					}
					else
					{
						rf_get_mode=0;
					}
					rf_high_time=0;
					rf_low_time=0;
				}
				else
				{
					if(rf_low_time<240)
					{
						rf_low_time++;
					}
				}
		}
		if(rf_get_mode==1)
		{
				if(pin_rf)
				{
					rf_high_time++;
				}
				else
				{
					if(rf_high_time<=25)
					{
						rf_get_mode=2;
					
					}
					else
					{
						rf_high_time=0;
						rf_low_time=0;
						rf_get_mode=0;
					}
				
				}
		}
		
		if(rf_get_mode==2)
		{
		
				if(!pin_rf)
				{
					rf_low_time++;
				}
				else
				{
					if(rf_low_time<=25)

					{
						rf_get_mode=3;
					
					}
					else
					{
						rf_high_time=0;
						rf_low_time=0;
						rf_get_mode=0;
					}
				
				}
		   	}
		if(rf_get_mode==3)
		{
				if(rf_low_time<rf_high_time)
				{
					rf_data[3]|=0x01;
				}
				rf_count++;
				if((rf_count%8)==0)
				{
					rf_data[0]=rf_data[1];
					rf_data[1]=rf_data[2];
					rf_data[2]=rf_data[3];
					rf_data[3]=0;
				}
				if(rf_count==24)
				{
					rf_low_time=0;
					rf_high_time=0;
					rf_get_mode=0;

					if(use_h==rf_data[0])
					{
						if(use_l==rf_data[1])
						{
							if(rf_yes==0)
							{
								rf_use_data=rf_data[2];
								rf_ok=1;
							}
							rf_yes=1;

						}
					}
				}
				else
				{
					rf_low_time=0;
					rf_high_time=0;
					rf_get_mode=1;

				}
				rf_data[3]<<=1;
			}
		
	}
	
	if(T0IF)
	{
		T0IF=0;//3.328ms
		T0C=100;


		if(z_delay)
		{
			time[0]++;
			if(time[0]>100)
			{
				time[0]=0;
				z_delay=0;
			}
		}
		if(motormode==4)
		{
			shan_time++;
			if(shan_time>51)
			{
				ff_time++;
				shan_time=0;
			}
		}




	}

	if(FTM0IRQ)//32768  1s
	{
		FTM0IRQ=0;	//־λ0
		if(z_timer)//ʱ
		{
			time[8]++;
			if(time[8]>59)
			{
				time[8]=0;
				time[9]++;
			}
			if(time[9]>59)
			{
				time[9]=0;
				time[10]++;
			}

			if(time[10]>=hour)
			{
				time[10]=0;
				on_off=0;z_timer=0;
			}
		}
		
	}
	

}