#line 1 ".\Src\MAIN.c"
#line 1 "C:\Sonix\SN8_C_~1.264\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\MAIN.c"
#line 1 ".\Include\fc2722.h"


#line 6 ".\Include\fc2722.h"




struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;











sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;
sfr	RBANK = 0x87;

 sfr     TM0M    =0X90;
 sfr    TM0CL   =0X91;
 sfr    TM0CH   =0X92;
 sfr    TM0D0L  =0X93;
 sfr    TM0D0H  =0X94;
 sfr    TM0D1L  =0X95;
 sfr    TM0D1H  =0X96;
 sfr    PWM0E   =0X97;

 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;



 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;

 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;

 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;


 sfr    P1OD = 0XDC;
 sfr    P3OD = 0Xdd;
 sfr    P3W = 0XDE;
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P3UR=0XE3;
 sfr	P1PD=0XEC;
 sfr	P3PD=0XEE;

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAB:2;
sbit	E2P_PG		=0xAB:1;
sbit	E2P_RD		=0xAB:0;



sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;




sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;





sbit	FPWM0OE		=0x90:0;
sbit	FALOAD0		=0x90:1;
sbit	FT0CKS0		=0x90:2;
sbit	FT0CKS1		=0x90:3;
sbit	FT0PS0		=0x90:4;
sbit	FT0PS1		=0x90:5;
sbit	FT0PS2		=0x90:6;
sbit	FTM0ENB		=0x90:7;

sbit	FPWM1OE		=0xA0:0;
sbit	FALOAD1		=0xA0:1;
sbit	FT1CKS0		=0xA0:2;
sbit	FT1CKS1		=0xA0:3;
sbit	FT1PS0		=0xA0:4;
sbit	FT1PS1		=0xA0:5;
sbit	FT1PS2		=0xA0:6;
sbit	FTM1ENB		=0xA0:7;

sbit	FPWM2OE		=0xB0:0;
sbit	FALOAD2		=0xB0:1;
sbit	FT2CKS0		=0xB0:2;
sbit	FT2CKS1		=0xB0:3;
sbit	FT2PS0		=0xB0:4;
sbit	FT2PS1		=0xB0:5;
sbit	FT2PS2		=0xB0:6;
sbit	FTM2ENB		=0xB0:7;


sbit	PWM01E		=0x97:0;
sbit	PWM00HL		=0x97:1;
sbit	PWM01HL		=0x97:2;
sbit	PWM0M		=0x97:3;
sbit	PWM00OE		=0x97:4;
sbit	PWM01OE		=0x97:5;
sbit	TC0WAKE		=0x97:6;
sbit	PWM0OD		=0x97:7;

sbit	PWM11E		=0xA6:0;
sbit	PWM10HL		=0xA6:1;
sbit	PWM11HL		=0xA6:2;
sbit	PWM1M		=0xA6:3;
sbit	PWM10OE		=0xA6:4;
sbit	PWM11OE		=0xA6:5;
sbit	TC1WAKE		=0xA6:6;
sbit	PWM1OD		=0xA6:7;

sbit	PWM21E		=0xB6:0;
sbit	PWM20HL		=0xB6:1;
sbit	PWM21HL		=0xB6:2;
sbit	PWM2M		=0xB6:3;
sbit	PWM20OE		=0xB6:4;
sbit	PWM21OE		=0xB6:5;
sbit	TC2WAKE		=0xB6:6;
sbit	PWM2OD		=0xB6:7;



sbit	INT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IEN		=0xc9:2;
sbit	FTM1IEN		=0xc9:3;
sbit	FTM2IEN		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	I2CIE		=0xc9:6;
sbit	ADCIE		=0xc9:7;

sbit	E2PIE		=0xc7:0;
sbit	TKTMRIE		=0xc7:1;
sbit	SPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	OPAIE    	=0xC7:4;

sbit	INT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IRQ		=0xc8:2;
sbit	FTM1IRQ		=0xc8:3;
sbit	FTM2IRQ		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	I2CIF		=0xc8:6;
sbit	ADCIF		=0xc8:7;

sbit	E2PIF		=0xc6:0;
sbit	TKTMRIF		=0xc6:1;
sbit	SPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	OPAIF    	=0xC6:4;

sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;

sbit	FP25 = 0xd2:5;
sbit	FP24 = 0xd2:4;
sbit	FP23 = 0xd2:3;
sbit	FP22 = 0xd2:2;
sbit	FP21 = 0xd2:1;
sbit	FP20 = 0xd2:0;

sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;

sbit	FP17M = 0xc1:7;
sbit	FP16M = 0xc1:6;
sbit	FP15M= 0xc1:5;
sbit	FP14M = 0xc1:4;
sbit	FP13M = 0xc1:3;
sbit	FP12M = 0xc1:2;
sbit	FP11M = 0xc1:1;
sbit	FP10M = 0xc1:0;

sbit	FP17UR = 0xe1:7;
sbit	FP16UR = 0xe1:6;
sbit	FP15UR= 0xe1:5;
sbit	FP14UR = 0xe1:4;
sbit	FP13UR = 0xe1:3;
sbit	FP12UR = 0xe1:2;
sbit	FP11UR = 0xe1:1;
sbit	FP10UR = 0xe1:0;


sbit	FP37M = 0xc3:7;
sbit	FP36M = 0xc3:6;
sbit	FP35M= 0xc3:5;
sbit	FP34M = 0xc3:4;
sbit	FP33M = 0xc3:3;
sbit	FP32M = 0xc3:2;
sbit	FP31M = 0xc3:1;
sbit	FP30M = 0xc3:0;



sbit	FCLKMD = 0xca:2;
sbit	FSTPHX = 0xca:1;

sbit	FP17PD = 0xEC:7;
sbit	FP16PD = 0xEC:6;
sbit	FP15PD = 0xEC:5;
sbit	FP14PD = 0xEC:4;
sbit	FP13PD = 0xEC:3;
sbit	FP12PD = 0xEC:2;
sbit	FP11PD = 0xEC:1;
sbit	FP10PD = 0xEC:0;

sbit	FP37PD = 0xEE:7;
sbit	FP36PD = 0xEE:6;
sbit	FP35PD = 0xEE:5;
sbit	FP34PD = 0xEE:4;
sbit	FP33PD = 0xEE:3;
sbit	FP32PD = 0xEE:2;
sbit	FP31PD = 0xEE:1;
sbit	FP30PD = 0xEE:0;

sbit	FGIE = 0xdf:7;

sbit	FSTKPB2= 0xDF:2;
sbit	FSTKPB1= 0xDF:1;
sbit	FSTKPB0= 0xDF:0;















#line 2 ".\Src\MAIN.c"
#line 1 ".\Include\E2PROM.H"




void E2promInit(void);
void e2prom_write(unsigned int e2_adders,unsigned int e2_data);
unsigned int e2prom_read(unsigned int e2_adders);



#line 3 ".\Src\MAIN.c"






unsigned int number=0;
unsigned int motormode=0,bright=0;
unsigned int shan_time=0,ff_time=0;
unsigned int time[15];
unsigned int limit,cishu,geshu,cnt;

unsigned int pwm[2],pich;
unsigned int speed,speed_mode;

unsigned int flag=0;
sbit on_off=flag:0;
sbit t0_use=flag:1;
sbit rf_ok=flag:2;
sbit z_write=flag:3;
sbit z_delay=flag:4;
sbit z_timer=flag:5;

sbit zp=flag:6;
sbit zf=flag:7;

unsigned int map=0;
sbit rf_yes=map:0;

unsigned int open=0;
unsigned int breth;









unsigned int rf_get_mode=0;
unsigned int rf_high_time,rf_low_time;
unsigned int rf_data[4];
unsigned int rf_count;
unsigned int rf_use_data;


void delay_5u()
{__asm{nop}__asm{nop}__asm{nop}__asm{nop}
__asm{nop}__asm{nop}__asm{nop}__asm{nop}
__asm{nop}__asm{nop}__asm{nop}__asm{nop}
__asm{nop}__asm{nop}__asm{nop}__asm{nop}}

void delay_us(unsigned int i)
{
	while(i--);
}




#line 71 ".\Src\MAIN.c"

void T0Init()
{

	T0M=0X80;
	T0C=100;
	T0IF=0;
	T0IE=1;
	FGIE=1;
}
void Tm0Init()
{

	TM0CL=0;
	TM0CH=0xff;
	TM0M=0x8e;

	FTM0IRQ=0;

	FTM0IEN=1;
}
void Tm1Init()
{

	TM1C=136;
	TM1M=0xd6;

	FTM1IRQ=0;

	FTM1IEN=0;
}

void Tm2Init()
{

	TM2C=0;
	TM2M=0xd2;

	FTM2IRQ=0;

	FTM2IEN=1;
}


void bright_mode()
{
	switch(bright)
	{
		case 10: geshu=100;limit=0;break;
		case 9:  geshu=78;limit=0;break;
		case 8:  geshu=70;limit=1;break;
		case 7:  geshu=62;limit=2;break;
		case 6:  geshu=55;limit=3;break;
		case 5:  geshu=44;limit=4;break;
		case 4:  geshu=36;limit=5;break;
		case 3:  geshu=27;limit=6;break;
		case 2:  geshu=19;limit=7;break;
		case 1:  geshu=10;limit=8;break;
		case 0:  geshu=2;limit=9;break;
	}

	{

		time[1]++;
		if(time[1]>=85)
		{
			time[1]=0;
		}


		if(time[1]<geshu)
		{

			if(cnt==1){FP15 =1;PWM1E=0x00;}
			else     {FP16 =1;PWM1E=0x00;}
			time[2]=0;
		}
		else
		{

#line 171 ".\Src\MAIN.c"
			{


						if(cnt==1){FP15 =0;PWM1E=0x21;TM1D1= 166;}
						else     {FP16 =0;PWM1E=0x42;TM1D2= 166;}

#line 179 ".\Src\MAIN.c"
			}
		}
	}





}

void breathe_mode()
{
	switch(bright)
	{
		case 10: pwm[0]=100;limit=0;break;
		case 9:  pwm[0]=78;limit=0;break;
		case 8:  pwm[0]=70;limit=1;break;
		case 7:  pwm[0]=62;limit=2;break;
		case 6:  pwm[0]=55;limit=3;break;
		case 5:  pwm[0]=44;limit=4;break;
		case 4:  pwm[0]=36;limit=5;break;
		case 3:  pwm[0]=27;limit=6;break;
		case 2:  pwm[0]=19;limit=7;break;
		case 1:  pwm[0]=10;limit=8;break;
		case 0:  pwm[0]=2;limit=9;break;
	}
switch(speed_mode)
{
	default: speed_mode=0;
	case 0: speed=1;break;
	case 1: speed=2;break;
	case 2: speed=4;break;
	case 3: speed=8;break;
}

	{


		time[3]++;
		if(time[3]>=85)
		{
			time[3]=0;

		}

			time[7]++;
			if(time[7]>=3)
			{
				time[5]++;
				time[7]=0;
				if(time[5]>=255)
				{
					time[5]=0;
					pich++;
				}
			}

			if(pwm[1]<128)
			{
				breth=1;
			}
			else
			{
				breth=2;
			}
		if(pich>=breth)
		{
			pich=0;
			if(zp)
			{
				if(pwm[1]<255-speed)
				{
				pwm[1]=speed+pwm[1];
				}
				else
				{
					zp=0;
				}
			}
			else
			{
				if(pwm[1]>1+speed)
				{
					pwm[1]=pwm[1]-speed;
				}
				else
				{
					zp=1;
					zf=~zf;
					if(zf)
					{
						speed_mode++;
					}
				}
			}

		}

		if(time[5]<pwm[1])
		{
			time[6]++;

				if(time[3]<pwm[0])
				{

					if(cnt==1){FP15 =1;PWM1E=0x00;}
					else     {FP16 =1;PWM1E=0x00;}
					time[4]=0;
				}
				else
				{

#line 311 ".\Src\MAIN.c"
					{

						if(cnt==1){FP15 =0;PWM1E=0x21;TM1D1= 166;}
						else     {FP16 =0;PWM1E=0x42;TM1D2= 166;}

#line 318 ".\Src\MAIN.c"

					}
				}

		}
		else
		{
			PWM1E=0x00;
			if(cnt==1){FP15 =0;PWM1E=0x00;}
			else     {FP16 =0;PWM1E=0x00;}
			time[6]=0;
		}



	}
}
void choosemode()
{
	switch(motormode)
	{

		case 1: cnt=2;bright_mode();FP15 =0;break;
		case 2: cnt=1;bright_mode();FP16 =0;break;
		case 3: if(zf)
				{
					cnt=1;breathe_mode();FP16 =0;
				}
				else
				{
					cnt=2;breathe_mode();FP15 =0;
				}
				break;
		case 4:
				if(ff_time<4)
				{
					cnt=1;bright_mode();FP16 =0;
				}
				else if(ff_time<8)
				{
					cnt=2;bright_mode();FP15 =0;
				}
				else
				{
					ff_time=0;FP15 =1;FP16 =0;cnt=1;
				}break;
	}
}

#line 369 ".\Src\MAIN.c"
void rf_batle()
{
	if(rf_ok)
	{
		rf_ok=0;
		z_write=1;
		z_delay=1;
		if(rf_use_data==0x01)
		{
			on_off=1;open=10;
		}
		if(rf_use_data==0x03)
		{
			on_off=0;z_timer=0;open=0;
		}
		if(on_off)
		{
			switch(rf_use_data)
			{
				case 0x04: motormode=1;break;
				case 0x06: motormode=2;break;
				case 0x07: cishu=0;motormode=3;speed_mode=0;zf=1;zp=1;pwm[1]=1;break;
				case 0x09: cishu=0;motormode=4;break;
				case 0x0a: if(bright>0)
							{bright--;}
							else
							{
								bright=0;
								z_delay=0;z_write=0;
							}

							break;
				case 0x0c: if(bright<10)
							{bright++;}
							else
							{
								bright=10;
								z_delay=0;z_write=0;
							}
							break;

				case 0x02: z_timer=1;break;

			}
		}

	}
	else
	{

		if(z_write)
		{
			z_write=0;
			e2prom_write(0x02,motormode);
			e2prom_write(0x03,bright);
			e2prom_write(0x05,open);
		}

	}
}

void keydown()
{
	if(FP34)
	{
		if(time[11]>150)
		{
			on_off=~on_off;
			if(on_off){open=10;}
			else{open=0;}
			z_write=1;
		}
		time[11]=0;
	}
	else
	{
		if(time[11]<250)
		{
		time[11]++;
		}

	}
	if(FP33)
	{
		if(time[12]>150)
		{
			if(on_off)
			{
				motormode++;
				if(motormode>4)
				{motormode=1; }
				z_write=1;z_delay=1;
			}
		}
		time[12]=0;
	}
	else
	{
		if(time[12]<250)
		{
		time[12]++;
		}

	}
}

#line 477 ".\Src\MAIN.c"
void main()
{
	P1M=0xf8;
	P3M=0x00;
	P3UR=0x18;
	P1=0x00;
	P3=0x00;
	T0Init();
	Tm0Init();
  	Tm1Init();
	Tm2Init();

	number=e2prom_read(0x04);
	if(number!=100)
	{
		motormode=1;
		bright=10;
		number=100;
		open=10;
e2prom_write(0x02,motormode);
e2prom_write(0x03,bright);
e2prom_write(0x04,number);
e2prom_write(0x05,open);

	}
motormode=e2prom_read(0x02);
bright=e2prom_read(0x03);
open=e2prom_read(0x05);

if(open)
{
	on_off=1;
}
else
{
	on_off=0;
}

z_delay=0;

	while(1)
	{

		rf_batle();
		keydown();
		if(on_off&&z_delay==0)
		{
			choosemode();
		}
		else
		{FP15 =0;FP16 =0;PWM1E=0x00;}
		WDTR=0x5a;

	}
}
void __interrupt[0x08] interrupt_isr(void)
{
	if(FTM2IRQ)
	{
		FTM2IRQ=0;

		if(rf_get_mode==0)
		{
				rf_count=0;
				rf_data[3]=0;
				if(FP35)
				{

					if((rf_low_time> 80)&&(rf_low_time< 200))
					{
						rf_get_mode=1;
					}
					else if(rf_low_time>220)
					{
						rf_yes=0;
					}
					else
					{
						rf_get_mode=0;
					}
					rf_high_time=0;
					rf_low_time=0;
				}
				else
				{
					if(rf_low_time<240)
					{
						rf_low_time++;
					}
				}
		}
		if(rf_get_mode==1)
		{
				if(FP35)
				{
					rf_high_time++;
				}
				else
				{
					if(rf_high_time<=25)
					{
						rf_get_mode=2;

					}
					else
					{
						rf_high_time=0;
						rf_low_time=0;
						rf_get_mode=0;
					}

				}
		}

		if(rf_get_mode==2)
		{

				if(! FP35)
				{
					rf_low_time++;
				}
				else
				{
					if(rf_low_time<=25)

					{
						rf_get_mode=3;

					}
					else
					{
						rf_high_time=0;
						rf_low_time=0;
						rf_get_mode=0;
					}

				}
		   	}
		if(rf_get_mode==3)
		{
				if(rf_low_time<rf_high_time)
				{
					rf_data[3]|=0x01;
				}
				rf_count++;
				if((rf_count%8)==0)
				{
					rf_data[0]=rf_data[1];
					rf_data[1]=rf_data[2];
					rf_data[2]=rf_data[3];
					rf_data[3]=0;
				}
				if(rf_count==24)
				{
					rf_low_time=0;
					rf_high_time=0;
					rf_get_mode=0;

					if(0xff ==rf_data[0])
					{
						if(0xff ==rf_data[1])
						{
							if(rf_yes==0)
							{
								rf_use_data=rf_data[2];
								rf_ok=1;
							}
							rf_yes=1;

						}
					}
				}
				else
				{
					rf_low_time=0;
					rf_high_time=0;
					rf_get_mode=1;

				}
				rf_data[3]<<=1;
			}

	}

	if(T0IF)
	{
		T0IF=0;
		T0C=100;


		if(z_delay)
		{
			time[0]++;
			if(time[0]>100)
			{
				time[0]=0;
				z_delay=0;
			}
		}
		if(motormode==4)
		{
			shan_time++;
			if(shan_time>51)
			{
				ff_time++;
				shan_time=0;
			}
		}




	}

	if(FTM0IRQ)
	{
		FTM0IRQ=0;
		if(z_timer)
		{
			time[8]++;
			if(time[8]>59)
			{
				time[8]=0;
				time[9]++;
			}
			if(time[9]>59)
			{
				time[9]=0;
				time[10]++;
			}

			if(time[10]>= 10)
			{
				time[10]=0;
				on_off=0;z_timer=0;
			}
		}

	}


}
